<?php

/**
 * Template engine class
 * @author  Alex Priadko <alex.priadko@yandex.ru>
 * @package Viplays
 */

class Template
{
	protected $vars = [];

	protected $template;

	protected $template_dir;

	public function __construct($dir)
	{
		$this->template_dir = $dir;
	}



	public function assign($variable,$value)
	{
		if (is_array($value)) {
			foreach ($value as $k=>$v) {
				$value[$k] = $this->escape($v);
			}
			$this->vars[$variable] = $value;
		} else {
			$this->vars[$variable] = $this->escape($value);
		}
		return $this;
	}

	public function globalAssign($data = [])
	{
		foreach ($data as $key => $value) {
			if (is_array($value)) {
				foreach ($value as $k=>$v) {
					$value[$k] = $this->escape($v);
				}
				$this->vars[$key] = $value;
			} else {
				$this->vars[$key] = $this->escape($value);
			}
		}
		return $this;
	}

	public function setTemplate($template_name)
	{
		$this->template = $template_name;
		return $this;
	}

	public function render()
	{
		if ($this->searchTemplate()) {
			return $this->executeTemplate();
		}
		return false;
	}

	private function escape($var)
	{
		return htmlentities($var);
	}

	private function searchTemplate()
	{
		if (file_exists($this->makePathToTemplate())) {
			return true;
		}
		return false;
	}

	private function executeTemplate()
	{
		ob_start();
		if (is_array($this->vars)) {
			extract($this->vars);
		}
		include_once $this->makePathToTemplate();
		ob_end_flush();
		return true;
	}

	private function makePathToTemplate()
	{
		return __DIR__ . '/'.$this->template_dir.'/'.$this->template.'.php';
	}
}